;TIP1193.LSP:  BOXTEXT.LSP   Hide Entities Below Text   (c)1996, Levin R. Trujillo

;--------------- Boxtext.lsp ------------------
(defun C:BOXTEXT ( / TXTSS CLAY NUM ITEM EN ED E1 P1 P2 PT1 PT2 PT3 PT4
  OFFSET ANG1 ANG2 LEN LEN1 ENT)
  (setvar "cmdecho" 0) (setq OSN (getvar "OSMODE"))
  (princ "\nSelect text to hide:")
  (setq TXTSS (ssget))
  (if TXTSS
    (progn
      ;creates a layer where to store 3dface entities
      (setq LNAME (getvar "clayer"))
      (if (tBLSEARCh "LAYER" "hide_text") 
        (command "_layer" "t" "hide_text" "set" "hide_text" "")
        (command "_layer" "make" "hide_text" "c" "1" "" "")
      );ifend
      (setq NUM (sslength TXTSS))
      (setq ITEM 0)
      (while (< ITEM NUM)
        (setq EN (ssname TXTSS ITEM))
        (setq ED (entget EN))
        (if (= (cdr (assoc 0 ED )) "TEXT")
          (progn
            (setq BXLST (textbox (entget EN)))
            (setq P1 (car BXLST) p2 (cadr BXLST))    ;lower left and upper right corners
            (setq LEN (abs (- (car P1) (car P2))))   ;text length
            (setq HT  (abs (- (cadr P1) (cadr P2)))) ;text height 
            (setq OFFSET (abs (cadr P1)))      ;descender length
            (setq IP (cdr (assoc 10 ED))) ;text ins pt
            (setq ANGTXT (cdr (assoc 50 ED)))
            (setq DIST (sqrt (+ (expt OFFSET 2) (expt OFFSET 2))))
            ;distance to lower left first point
            (setq PNT1 (polar IP (+ (/ (* 5 pi) 4) ANGTXT) DIST))
            (setq PNT2 (polar PNT1 angtxt (+ LEN OFFSET)))
            (setq PNT3 (polar PNT2 (+ (/ pi 2) ANGTXT) HT))
            (setq PNT4 (polar PNT1 (+ (/ pi 2) ANGTXT) HT))
            (command "_3dface" PNT1 PNT2 PNT3 PNT4 "")
            (command "_change" (entlast) "" "P" "E" 0.1 "")
          );endprogn
        );endif
        (setq ITEM (1+ ITEM))
      );whilend
      (command "hide")
    );progn
    (prompt"\nNothing was selected. Try again")
  );if
  (command "_LAYER" "set" LNAME "")
  (command "_LAYER" "F" "hide_text" "")
  (setvar "OSMODE" osn)
  (prin1)
); end boxtext.lsp
